import { type ExportInstance } from '../model/ExportInstanceModel';
/**
 * 这里是实际提供给外部使用的方法，也同时保存整个应用的所有layer信息
 */
declare const _default: {
    /**
     * 增加一个新的layer
     * @param id
     * @param group
     * @param instance
     */
    add: (instance: ExportInstance) => void;
    /**
     * 是否需要唯一
     * @param unique
     */
    has: (unique: string | null | undefined) => boolean;
    /**
     * 设置为最顶
     * @param id
     */
    top: (id: string | ExportInstance) => void;
    /**
     * 关才卸载当前Layer
     * 这里实际上是直接UNMOUNT
     * @param instance
     */
    close: (instance: ExportInstance) => void;
    remove(id: string, unique?: string): void;
    closeAll(): void;
};
export default _default;
